--[[--------------
Do NOT edit this file if you don't know what you're doing.
Configuration is now stored at your SavedVariables.
]]----------------
local addon, ns = ...
RaidB_DB = {}
local f = CreateFrame("Frame", "SacriRaidBuffed", UIParent)
--[[
	Buff List
	http://www.wowhead.com/guide=1100
]]--

local applyDragFunctionality = function(f,userplaced,locked)
	f:SetScript("OnDragStart", function(s) if IsShiftKeyDown() then s:StartMoving() end end)
	f:SetScript("OnDragStop", function(s) s:StopMovingOrSizing() end)
     
	local t = f:CreateTexture(nil,"OVERLAY",nil,6)
	t:SetAllPoints(f)
	t:SetTexture(0,1,0)
	t:SetAlpha(0)
	f.dragtexture = t    
	f:SetHitRectInsets(-50,-50, -50, -50)

	if not userplaced then
		f:SetMovable(false)
	else
		f:SetMovable(true)
		f:SetUserPlaced(true)
		if not locked then
			f.dragtexture:SetAlpha(0.2)
			f:EnableMouse(true)
			f:RegisterForDrag("LeftButton")
			f:SetScript("OnEnter", function(s) 
				GameTooltip:SetOwner(s, "ANCHOR_TOP")
				GameTooltip:AddLine(s:GetName(), 0, 1, 0.5, 1, 1, 1)
				GameTooltip:AddLine("Hold down ALT+SHIFT to drag!", 1, 1, 1, 1, 1, 1)
				GameTooltip:Show()
				end)
			f:SetScript("OnLeave", function(s) GameTooltip:Hide() end)
		else
			f.dragtexture:SetAlpha(0)
			f:EnableMouse(nil)
			f:RegisterForDrag(nil)
			f:SetScript("OnEnter", nil)
			f:SetScript("OnLeave", nil)
		end
	end  
end
applyDragFunctionality(f, true, true)
  
f.n = NUM_LE_RAID_BUFF_TYPES

local function cap(str)
    return (str:gsub("^%l", string.upper))
end

do
	f.Locale = LibStub("LibBabble-TalentTree-3.0"):GetLookupTable()
	f.classes = {}
	local numClasses = GetNumClasses();
	local classDisplayName, classTag
	for i = 1, numClasses do
		classDisplayName, classTag = GetClassInfo(i);
		f.classes[classTag] = classDisplayName			
	end
end

local GetSpellInfo = GetSpellInfo
local UnitBuff = UnitBuff
local BLIndex = 12
local AugIndex = 13

function f:init()
     --print("init")
	if RaidB_DB.showfoodFlask and RaidB_DB.showHeroism then     --both heroism and food/flask
	f.n = NUM_LE_RAID_BUFF_TYPES+3
	elseif RaidB_DB.showfoodFlask and not RaidB_DB.showHeroism then --only food/flask
	f.n = NUM_LE_RAID_BUFF_TYPES+2
	elseif RaidB_DB.showHeroism and not RaidB_DB.showfoodFlask then --only heroism
    f.n = NUM_LE_RAID_BUFF_TYPES+1
	BLIndex = 10
	end
	
	if RaidB_DB.showAugmentedRune then
		f.n = f.n+1
		AugIndex = f.n
	end
   

	if RaidB_DB.vert then
	f:SetHeight((RaidB_DB.iconsPerRowOrColumn * (RaidB_DB.icondimension + RaidB_DB.gap))-RaidB_DB.gap)
	f:SetWidth((math.ceil(f.n / RaidB_DB.iconsPerRowOrColumn) * (RaidB_DB.icondimension + RaidB_DB.gap))-RaidB_DB.gap)
	else	
	f:SetWidth((RaidB_DB.iconsPerRowOrColumn * (RaidB_DB.icondimension + RaidB_DB.gap))-RaidB_DB.gap)
	f:SetHeight((math.ceil(f.n / RaidB_DB.iconsPerRowOrColumn) * (RaidB_DB.icondimension + RaidB_DB.gap))-RaidB_DB.gap)
	end
	
	f:SetPoint(RaidB_DB.fp, "UIParent", RaidB_DB.sp, RaidB_DB.x, RaidB_DB.y)
	
	self:SetScript("OnUpdate", self.OnUpdate)
end

function f:CreateButton(i)
	local btn = CreateFrame("Frame", "SRB"..i, f)
	btn.caster = nil
	
	local any = cap(SPELL_TARGET_TYPE1_DESC)
	local pet = cap(PET)
	
	local strany = "%s %s"				-- Any DRUID
	local strpet = "%s %s (%s: %s)"		-- Any WARLOCK (Pet: Imp)
	local bm = f.classes["HUNTER"]..": "..f.Locale["Beast Mastery"].." ("..pet..": ".."%s)"
	local str1spec = "%s: %s"			-- Shaman: Enhancement
	local str2spec = "%s: %s, %s"		-- DK: frost, unholy
	if i == 1 then
		btn.bt =  "Interface\\ICONS\\spell_nature_regeneration"
		btn.desc = RAID_BUFF_1 --"Stats"
		btn.given = {
			strany:format(any, f.classes["DRUID"]),
			strany:format(any, f.classes["MONK"]),
			strany:format(any, f.classes["PALADIN"]),
			strpet:format(any, f.classes["HUNTER"], pet, "Dog, Gorilla"),
			bm:format("Shale Spider, Worm"),
		}
	elseif i == 2 then
		btn.bt = "Interface\\ICONS\\spell_holy_wordfortitude"
		btn.desc = RAID_BUFF_2 --"Stamina"
		btn.given = {
			strany:format(any, f.classes["PRIEST"]),
			strany:format(any, f.classes["WARLOCK"]),
			strany:format(any, f.classes["WARRIOR"]),
			strpet:format(any, f.classes["HUNTER"], pet, "Bear, Goat, Rylak"),
			bm:format("Silithid"),
		}
	elseif i == 3 then
		btn.bt = "Interface\\ICONS\\ability_warrior_battleshout"
		btn.desc = RAID_BUFF_3 --"Attack Power"
		btn.given = {
			strany:format(any, f.classes["DEATHKNIGHT"]),
			strany:format(any, f.classes["HUNTER"]),
			strany:format(any, f.classes["WARRIOR"]),
		}
	elseif i == 4 then
		btn.bt = "Interface\\ICONS\\inv_helmet_08"
		btn.desc = RAID_BUFF_4 --"Haste"
		btn.given = {
			str2spec:format(f.classes["DEATHKNIGHT"], f.Locale["Frost"], f.Locale["Unholy"]),
			str1spec:format(f.classes["PRIEST"], f.Locale["Shadow"]),
			strany:format(any, f.classes["ROGUE"]),
			strany:format(any, f.classes["SHAMAN"]),
			strpet:format(any, f.classes["HUNTER"], pet, "Hyena, Rylak, Sporebat, Wasp"),
		}		
	elseif i == 5 then
		btn.bt = "Interface\\ICONS\\spell_holy_magicalsentry"
		btn.desc = RAID_BUFF_5 --"Spell Power"
		btn.given = {
			strany:format(any, f.classes["MAGE"]),
			strany:format(any, f.classes["WARLOCK"]),
			strpet:format(any, f.classes["HUNTER"], pet, "Serpent"),
			bm:format("Silithid, Waterstrider"),
		}
	elseif i == 6 then
		btn.bt = "Interface\\ICONS\\spell_nature_unyeildingstamina"
		btn.desc = RAID_BUFF_6--"Crit"
		btn.given = {
			str1spec:format(f.classes["DRUID"], f.Locale["Feral"]),
			strany:format(any, f.classes["MAGE"]),
			str2spec:format(f.classes["MONK"], f.Locale["Brewmaster"], f.Locale["Windwalker"]),
			strpet:format(any, f.classes["HUNTER"], pet, "Raptor, Wolf"),
			bm:format("Devilsaur, Quilen, Shale Spider, Waterstrider"),
		}
	elseif i == 7 then
		btn.bt = "Interface\\ICONS\\spell_holy_greaterblessingofkings"
		btn.desc = RAID_BUFF_7--"Mastery"
		btn.given = {
			str1spec:format(f.classes["DEATHKNIGHT"], f.Locale["Blood"]),
			str1spec:format(f.classes["DRUID"], f.Locale["Balance"]),
			strany:format(any, f.classes["PALADIN"]),
			strany:format(any, f.classes["SHAMAN"]),
			strpet:format(any, f.classes["HUNTER"], pet, "Cat, Hydra, Tallstrider"),
			bm:format("Spirit Beast"),
		}
	elseif i == 8 then
		btn.bt = "Interface\\ICONS\\inv_elemental_mote_air01"
		btn.desc = RAID_BUFF_8--"Multistrike"
		btn.given = {
			str1spec:format(f.classes["MONK"], f.Locale["Windwalker"]),
			str1spec:format(f.classes["PRIEST"], f.Locale["Shadow"]),
			strany:format(any, f.classes["ROGUE"]),
			strany:format(any, f.classes["WARLOCK"]),
			strpet:format(any, f.classes["HUNTER"], pet, "Bat, Clefthoof, Dragonhawk, Wind Serpent"),
			bm:format("Core Hound"),
		}
	elseif i == 9 then
		btn.bt = "Interface\\ICONS\\spell_holy_mindvision"
		btn.desc = RAID_BUFF_9--"Versatility"
		btn.given = {
			str2spec:format(f.classes["DEATHKNIGHT"], f.Locale["Frost"], f.Locale["Unholy"]),
			strany:format(any, f.classes["DRUID"]),
			str1spec:format(f.classes["PALADIN"], f.Locale["Retribution"]),
			str2spec:format(f.classes["WARRIOR"], f.Locale["Arms"], f.Locale["Fury"]),
			strpet:format(any, f.classes["HUNTER"], pet, "Bird of Prey, Boar, Clefthoof, Porcupine, Ravager, Stag"),
			bm:format("Worm"),
		}
	end
	
	if (not (RaidB_DB.showfoodFlask and RaidB_DB.showHeroism)) or (not RaidB_DB.showBloodlustBeforeFood) then
		if i == 10 then
			if RaidB_DB.showfoodFlask then
		   
			btn.bt = "Interface\\ICONS\\spell_misc_food"
			btn.desc = (GetSpellInfo(104267))
			btn.given = {
				POWER_TYPE_FOOD
			}
			btn.caster = "player"
			else
			  if RaidB_DB.showHordeMode then
			  btn.bt = "Interface\\ICONS\\spell_nature_bloodlust"
			  else
			  btn.bt = "Interface\\ICONS\\ability_shaman_heroism"
			  end
			btn.desc = ITEM_MOD_HASTE_RATING_SHORT --"Haste"
			btn.given = {
				strany:format(any, f.classes["MAGE"]),
				strany:format(any, f.classes["SHAMAN"]),
				bm:format("Core Hound"),
			}
			btn.alert = CreateFrame("Frame", "SRBOverlay", btn, "ActionBarButtonSpellActivationAlert");
			btn.alert:SetAllPoints(btn)
			end
		elseif i == 11 then
			btn.bt = "Interface\\ICONS\\trade_alchemy_potione5"
			btn.desc = (select(4, GetAuctionItemSubClasses(4))) --"Flask"
			btn.given = {
				(select(4, GetAuctionItemSubClasses(4))),
			}
			btn.caster = "player"
		elseif i == 12 then
			  if RaidB_DB.showHordeMode then
			  btn.bt = "Interface\\ICONS\\spell_nature_bloodlust"
			  else
			  btn.bt = "Interface\\ICONS\\ability_shaman_heroism"
			  end
			btn.desc = ITEM_MOD_HASTE_RATING_SHORT --"Haste"
			btn.given = {
				strany:format(any, f.classes["MAGE"]),
				strany:format(any, f.classes["SHAMAN"]),
				bm:format("Core Hound"),
			}
			btn.alert = CreateFrame("Frame", "SRBOverlay", btn, "ActionBarButtonSpellActivationAlert");
			btn.alert:SetAllPoints(btn)
		end
	elseif RaidB_DB.showBloodlustBeforeFood and (RaidB_DB.showfoodFlask and RaidB_DB.showHeroism) then
		BLIndex = 10
		if i == 10 then
			  if RaidB_DB.showHordeMode then
			  btn.bt = "Interface\\ICONS\\spell_nature_bloodlust"
			  else
			  btn.bt = "Interface\\ICONS\\ability_shaman_heroism"
			  end
			btn.desc = ITEM_MOD_HASTE_RATING_SHORT --"Haste"
			btn.given = {
				strany:format(any, f.classes["MAGE"]),
				strany:format(any, f.classes["SHAMAN"]),
				bm:format("Core Hound"),
			}
			btn.alert = CreateFrame("Frame", "SRBOverlay", btn, "ActionBarButtonSpellActivationAlert");
			btn.alert:SetAllPoints(btn)

		elseif i == 11 then
			btn.bt = "Interface\\ICONS\\spell_misc_food"
			btn.desc = (GetSpellInfo(104267))
			btn.given = {
				POWER_TYPE_FOOD
			}
			btn.caster = "player"
		elseif i == 12 then
			btn.bt = "Interface\\ICONS\\trade_alchemy_potione5"
			btn.desc = (select(4, GetAuctionItemSubClasses(4))) --"Flask"
			btn.given = {
				(select(4, GetAuctionItemSubClasses(4))),
			}
			btn.caster = "player"
		end	
	end
	
	if RaidB_DB.showAugmentedRune and i == AugIndex then
			btn.bt = "Interface\\ICONS\\inv_misc_rune_12"
			btn.desc = "Rune" 
			btn.given = "Rune consumable"
			btn.caster = "player"
	end


	if RaidB_DB.showTooltip then
	
		btn:SetScript("OnEnter", function(self) 
				GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT")
				GameTooltip:ClearLines()
				GameTooltip:AddLine(self.desc)
				for i = 1, #btn.given do
					GameTooltip:AddLine(btn.given[i])
				end
				if self.caster ~= nil then
					local _, classFileName = UnitClass(self.caster)
					local color = RAID_CLASS_COLORS[classFileName]
					GameTooltip:AddLine("Caster: "..GetUnitName(self.caster, false), color.r, color.g, color.b)
				end
				GameTooltip:Show()
			end)
			
		btn:SetScript("OnLeave", function(self) 
				GameTooltip:Hide()
			end)
	
	end
	
	btn:SetHeight(RaidB_DB.icondimension)
	btn:SetWidth(RaidB_DB.icondimension)
	btn.bg = btn:CreateTexture(nil, "BACKGROUND")
	btn.bg:SetAllPoints(btn)
	btn.bg:SetTexture(btn.bt)
	
	if not RaidB_DB.usingcustomicons then
		btn.bg:SetTexCoord(.08, .92, .08, .92)
	end
	
	

	if RaidB_DB.useaurora and IsAddOnLoaded("Aurora") then

		local auroraF, auroraC = unpack(Aurora)
		auroraF.SetBD(btn, 0,0,0,0)--, -1, 1, 1, -1)
		
	elseif RaidB_DB.usebeautycase and IsAddOnLoaded("!Beautycase") then
	
		CreateBorder(btn, RaidB_DB.bcbordersize, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1)
		
	elseif RaidB_DB.addborder then	-- TY nin
	
		btn:SetBackdrop(RaidB_DB.backdrop)
		btn:SetBackdropColor(0,0,0,0)
		btn:SetBackdropBorderColor(0,0,0)
		
	end

	
	btn:SetAlpha(RaidB_DB.koA)
	btn:Show()
	
	if not RaidB_DB.desaturate then
		hooksecurefunc(btn, "SetAlpha", function(btn, i) 
			if i == RaidB_DB.koA then
				btn.bg:SetTexture(btn.bt)
			end
		end)
	end
	
	
	return btn
end	

function f:GROUP_ROSTER_UPDATE()
	if GetNumGroupMembers() == 0 then
		f:Hide()
	else
		f:Show()
	end
end

function OptionsInit()
 --DEFAULT OPTIONS
 local Def_DB =  {
    icondimension = 24,
	gap = 0,
	okA = 0.9,
	koA = 0.5,
	vert = true,	
	iconsPerRowOrColumn = 12,
	goleft = true,
	godown = true,
	showTooltip = false,
	showfoodFlask = true,
	showHeroism = false,
	showHordeMode = true,
	showBloodlustBeforeFood = false, --shows bloodlust/heroism before the food/flask buffs
	showAugmentedRune = false,
	fadeCombat = false,
	fadeCombatAlpha  = 0.0,
	usingcustomicons = false,
	useaurora = false,
	usebeautycase = false,
	bcbordersize = 6,
	addborder = false,
	backdrop = {
		bgFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
		edgeFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
		edgeSize = 1,
		insets = {
			left = -1,
			right = -1,
			top = -1,
			bottom = -1,
		}
	},
	desaturate = true,
	showifalone = true,
	fp = "LEFT",
	sp = "LEFT",
	x = 0,
	y = -200,
 
                 }
				 
				 return Def_DB

end

function f:ADDON_LOADED(event, arg1, ...)

	if arg1 == "SacriRaidBuffed" then
		
		if next(RaidB_DB)==nil then
		  RaidB_DB = OptionsInit()
		end
		
		if RaidB_DB.showBloodlustBeforeFood==nil then
		  RaidB_DB.showBloodlustBeforeFood = false
		end
		
		if RaidB_DB.showAugmentedRune==nil then
			RaidB_DB.showAugmentedRune = false
		end
		
		f:init()
		f:RegisterForEvents()
		f:UnregisterEvent("ADDON_LOADED");
		for i=1,f.n do
	
			f[i] = f:CreateButton(i)

			RaidB_DB.iconsPerRowOrColumn = math.floor(RaidB_DB.iconsPerRowOrColumn)
			if RaidB_DB.iconsPerRowOrColumn < 0 then
				RaidB_DB.iconsPerRowOrColumn = f.n
			end
			
			if i == 1 then
				if RaidB_DB.godown and RaidB_DB.goleft then
					f[i]:SetPoint("TOPRIGHT", f, "TOPRIGHT", 0, 0)
				elseif RaidB_DB.godown and RaidB_DB.goleft == false then
					f[i]:SetPoint("TOPLEFT", f, "TOPLEFT", 0, 0)
				elseif not RaidB_DB.godown and RaidB_DB.goleft then
					f[i]:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 0, 0)
				else
					f[i]:SetPoint("BOTTOMLEFT", f, "BOTTOMLEFT", 0, 0)
				end
			else
				if RaidB_DB.vert then
					if i % RaidB_DB.iconsPerRowOrColumn == 1 then
						if RaidB_DB.goleft then
							f[i]:SetPoint("RIGHT", f[i-RaidB_DB.iconsPerRowOrColumn], "LEFT", -RaidB_DB.gap, 0)
						else
							f[i]:SetPoint("LEFT", f[i-RaidB_DB.iconsPerRowOrColumn], "RIGHT", RaidB_DB.gap, 0)
						end
					else
						if RaidB_DB.godown then
							f[i]:SetPoint("TOP", f[i-1], "BOTTOM", 0, -RaidB_DB.gap)
						else
							f[i]:SetPoint("BOTTOM", f[i-1], "TOP", 0, RaidB_DB.gap)
						end
					end
				else
					if i % RaidB_DB.iconsPerRowOrColumn == 1 then
						if RaidB_DB.godown then
							f[i]:SetPoint("TOP", f[i-RaidB_DB.iconsPerRowOrColumn], "BOTTOM", 0, -RaidB_DB.gap)
						else
							f[i]:SetPoint("BOTTOM", f[i-RaidB_DB.iconsPerRowOrColumn], "TOP", 0, RaidB_DB.gap)
						end
					else
						if RaidB_DB.goleft then
							f[i]:SetPoint("RIGHT", f[i-1], "LEFT", -RaidB_DB.gap, 0)
						else
							f[i]:SetPoint("LEFT", f[i-1], "RIGHT", RaidB_DB.gap, 0)
						end
					end
				end				
			end
			
		end

		f:Show()
		if RaidB_DB.showifalone == false then
			f:GROUP_ROSTER_UPDATE()
		end

	end

end


function f:CheckFlask()

	local _, texture
	local flasks = {156070, 156071, 156073, 156077, 156064, 156079, 156080, 156084, 176151} --, 79472 }
	for i = 1, #flasks do
		local name =(GetSpellInfo(flasks[i]))
		_, _, texture = UnitBuff("Player", name)
		if texture then
			return texture
		end
	end
	return nil
	
end

function f:CheckHero()
	local _, texture
	local bursthaste =	{ 80353, 2825, 32182, 90355, 160452, 146555}-- Time Warp/BL/Heroism/AHysteria/Netherwinds/Drums
	
	for i = 1, #bursthaste do
		local name =(GetSpellInfo(bursthaste[i]))
		_, _, texture, _, _, _, _, caster = UnitBuff("Player", name)
		if texture then
			ActionButton_ShowOverlayGlow(f[BLIndex].alert)
			return texture, caster
		end
	end
	ActionButton_HideOverlayGlow(f[BLIndex].alert)
	return nil
end

function f:CheckAug()
	local _, texture
	local augRune =	{ 175439, 175457, 175456, 190668}-- Stout/Focus/Hyper/Empowered Aug Rune
	
	for i = 1, #augRune do
		local name =(GetSpellInfo(augRune[i]))
		_, _, texture = UnitBuff("Player", name)
		if texture then
			return texture
		end
	end
	return nil

end

-- Thanks, Sintacks!
f.buffs = {
--                    Druid    Monk     Monk     Pally    LW       PG       Hunter Pets                                        			LoneW
	stats 		=	{   1126 , 115921 , 116781 ,  20217 ,  69378 , 144053 , 159988 , 160017 ,  90363 , 160077 				  		, 160206			},
--                    Priest   Warlock  Warrior           Scribe   PG       Hunter Pets
	stamina		= 	{  21562 , 166928 ,    469 ,          111922 , 144051 , 160003 , 160014 ,  90364 , 50256						, 160199			},
--                    DK       Hunter   Warrior                    PG   	
	attackpower	= 	{  57330 ,  19506 ,   6673 ,                   144041 																				},
--                    DK       Priest   Rogue    Shaman            PG       Hunter Pets
	haste		= 	{ 55610  ,  49868 , 113742 , 116956 ,          144046 , 160003 , 135678 , 160074 , 128432					    , 160203			},	
--                    Mage     Mage     Warlock                    PG       Hunter Pets
	spellpower	=	{   1459 ,  61316 , 109773 ,                   144042 , 126309 , 128433 										, 160205			},
--                    Druid    Mage     Mage     Monk              PG       Hunter Pets
	crit		=	{  17007 ,   1459 ,  61316 , 116781 ,          144047 ,  90309 , 126373 , 160052 ,  90363 , 126309 , 24604		, 160200			},
--                    DK       Druid    Pally    Shaman            PG       Hunter Pets
	mastery		=	{ 155522 ,  24907 ,  19740 , 116956 ,          144048 ,  93435 , 160039 , 128997 , 160073						, 160198			},
--                    Monk     Priest   Rogue    Warlock           PG       Hunter Pets
	multistrike =	{ 166916 ,  49868 , 113742 , 109773 ,          175651 ,  50519 ,  58604 ,  34889 ,  57386 ,  24844 , 159736     , 172968		    },
--                    DK       Druid    Pally    Warrior           PG       Hunter Pets
	versatility =	{ 55610  ,   1126 , 167187 , 167188 ,          175649 , 159735 ,  35290 ,  57386 , 160045 ,  50518 , 173035, 160077, 172967			},
}

--mop buffs
--[[
f.buffs = {
	stat 		=	{ 90363, 20217,	115921, 1126 },
	stamina		= 	{ 469, 109773, 90364, 21562},
	atkpwr		= 	{ 19506, 57330,	6673 },
	atkspeed	=	{ 55610, 113742, 30809, 128432, 128433 },
	spllpwr		=	{ 77747, 109773, 126309, 61316, 1459 },
	spllhaste	= 	{ 24907, 15473, 51470, 49868, 135678 },
	crit		=	{ 17007, 1459, 61316, 116781, 97229, 24604, 90309, 126373, 126309 },
	mastery		=	{ 116956, 19740, 93435, 128997 },
}
]]--

local function GetRaidBuffTrayAuraInfo(i)
	if i == 1 then
		for j = 1, #f.buffs.stats do
			local name, _, texture, _, _, _, _, caster = UnitBuff("Player", (GetSpellInfo(f.buffs.stats[j])))
			if texture then
				return name, _, texture, caster
			end
		end
	elseif i == 2 then
		for j = 1, #f.buffs.stamina do
			local name, _, texture, _, _, _, _, caster, _, _, spellId = UnitBuff("Player", (GetSpellInfo(f.buffs.stamina[j])))
			if texture and spellId ~= 137593 then
				return name, _, texture, caster
			end
		end
	elseif i == 3 then
		for j = 1, #f.buffs.attackpower do
			local name, _, texture, _, _, _, _, caster = UnitBuff("Player", (GetSpellInfo(f.buffs.attackpower[j])))
			if texture then
				return name, _, texture, caster
			end
		end
	elseif i == 4 then
		for j = 1, #f.buffs.haste do
			local name, _, texture, _, _, _, _, caster = UnitBuff("Player", (GetSpellInfo(f.buffs.haste[j])))
			if texture then
				return name, _, texture, caster
			end
		end
	elseif i == 5 then
		for j = 1, #f.buffs.spellpower do
			local name, _, texture, _, _, _, _, caster = UnitBuff("Player", (GetSpellInfo(f.buffs.spellpower[j])))
			if texture then
				return name, _, texture, caster
			end
		end
	elseif i == 6 then
		for j = 1, #f.buffs.crit do
			local name, _, texture, _, _, _, _, caster = UnitBuff("Player", (GetSpellInfo(f.buffs.crit[j])))
			if texture then
				return name, _, texture, caster
			end
		end
	elseif i == 7 then
		for j = 1, #f.buffs.mastery do
			local name, _, texture, _, _, _, _, caster = UnitBuff("Player", (GetSpellInfo(f.buffs.mastery[j])))
			if texture then
				return name, _, texture, caster
			end
		end
	elseif i == 8 then
		for j = 1, #f.buffs.multistrike do
			local name, _, texture, _, _, _, _, caster = UnitBuff("Player", (GetSpellInfo(f.buffs.multistrike[j])))
			if texture then
				return name, _, texture, caster
			end
		end
	elseif i == 9 then
		for j = 1, #f.buffs.versatility do
			local name, _, texture, _, _, _, _, caster = UnitBuff("Player", (GetSpellInfo(f.buffs.versatility[j])))
			if texture then
				return name, _, texture, caster
			end
		end
	else 
		return nil, nil, nil
	end

end

local e = 0
local dt = 1.0
function f:OnUpdate(elapsed)
  e = e + elapsed
  if(e > dt) then
    e = 0
	f:PLAYER_AURAS_CHANGED()
  end
end

function f:PLAYER_AURAS_CHANGED()
	for i=1,NUM_LE_RAID_BUFF_TYPES do
		local name, _, texture, caster = GetRaidBuffTrayAuraInfo(i);
		
		if name then 	
			if caster then
				f[i].caster = caster
			end
			f[i].bg:SetTexture(texture)
			f[i]:SetAlpha(RaidB_DB.okA)
			if RaidB_DB.desaturate then
			f[i].bg:SetDesaturated(false)
			end
		else
			f[i].caster = nil
			f[i]:SetAlpha(RaidB_DB.koA)
			f[i].bg:SetTexture(f[i].bt)
			--print(f[i].bt)
			if RaidB_DB.desaturate then
			f[i].bg:SetDesaturated(true)
			end
		end
	end
	
	if RaidB_DB.showAugmentedRune then
		local runed = f:CheckAug()
		if runed then
			f[AugIndex].bg:SetTexture(runed)
			f[AugIndex]:SetAlpha(RaidB_DB.okA)
			
			if RaidB_DB.desaturate then
			f[AugIndex].bg:SetDesaturated(false)
			end
		else
			f[AugIndex]:SetAlpha(RaidB_DB.koA)
			
			if RaidB_DB.desaturate then
			f[AugIndex].bg:SetDesaturated(true)
			end
		end
		
	end
	
	if (not (RaidB_DB.showfoodFlask and RaidB_DB.showHeroism)) or (not RaidB_DB.showBloodlustBeforeFood and (RaidB_DB.showfoodFlask or RaidB_DB.showHeroism)) then
		if RaidB_DB.showfoodFlask then
			local _, _, texture = UnitBuff("Player", (GetSpellInfo(104267)))
			if texture then
				f[NUM_LE_RAID_BUFF_TYPES+1].bg:SetTexture(texture)
				f[NUM_LE_RAID_BUFF_TYPES+1]:SetAlpha(RaidB_DB.okA)
				
				if RaidB_DB.desaturate then
				f[NUM_LE_RAID_BUFF_TYPES+1].bg:SetDesaturated(false)
				end
			else
				f[NUM_LE_RAID_BUFF_TYPES+1]:SetAlpha(RaidB_DB.koA)
				
				if RaidB_DB.desaturate then
				f[NUM_LE_RAID_BUFF_TYPES+1].bg:SetDesaturated(true)
				end
			end
			
			local flasked = f:CheckFlask()
			if flasked then
				f[NUM_LE_RAID_BUFF_TYPES+2].bg:SetTexture(flasked)
				f[NUM_LE_RAID_BUFF_TYPES+2]:SetAlpha(RaidB_DB.okA)
				
				if RaidB_DB.desaturate then
				f[NUM_LE_RAID_BUFF_TYPES+2].bg:SetDesaturated(false)
				end
			else
				f[NUM_LE_RAID_BUFF_TYPES+2]:SetAlpha(RaidB_DB.koA)
				
				if RaidB_DB.desaturate then
				f[NUM_LE_RAID_BUFF_TYPES+2].bg:SetDesaturated(true)
				end
			end
			

		end
	
		if RaidB_DB.showHeroism then 
		
		   local hero, caster = f:CheckHero()
			if hero then
				if caster then
					f[BLIndex].caster = caster
				end
				f[BLIndex].bg:SetTexture(hero)
				f[BLIndex]:SetAlpha(RaidB_DB.okA)
				
				if RaidB_DB.desaturate then
				f[BLIndex].bg:SetDesaturated(false)
				end
			else
				f[BLIndex].caster = nil
				f[BLIndex]:SetAlpha(RaidB_DB.koA)
				f[BLIndex].bg:SetTexture(f[BLIndex].bt)				
				if RaidB_DB.desaturate then
				f[BLIndex].bg:SetDesaturated(true)
				end
			end
		end
	 elseif RaidB_DB.showBloodlustBeforeFood and (RaidB_DB.showfoodFlask and RaidB_DB.showHeroism) then

			local _, _, texture = UnitBuff("Player", (GetSpellInfo(104267)))
			if texture then
				f[NUM_LE_RAID_BUFF_TYPES+2].bg:SetTexture(texture)
				f[NUM_LE_RAID_BUFF_TYPES+2]:SetAlpha(RaidB_DB.okA)
				
				if RaidB_DB.desaturate then
				f[NUM_LE_RAID_BUFF_TYPES+2].bg:SetDesaturated(false)
				end
			else
				f[NUM_LE_RAID_BUFF_TYPES+2]:SetAlpha(RaidB_DB.koA)
				
				if RaidB_DB.desaturate then
				f[NUM_LE_RAID_BUFF_TYPES+2].bg:SetDesaturated(true)
				end
			end
			
			local flasked = f:CheckFlask()
			if flasked then
				f[f.n].bg:SetTexture(flasked)
				f[f.n]:SetAlpha(RaidB_DB.okA)
				
				if RaidB_DB.desaturate then
				f[f.n].bg:SetDesaturated(false)
				end
			else
				f[f.n]:SetAlpha(RaidB_DB.koA)
				
				if RaidB_DB.desaturate then
				f[f.n].bg:SetDesaturated(true)
				end
			end

		   local hero, caster = f:CheckHero()
		    if hero then
				if caster then
					f[BLIndex].caster = caster
				end
				f[BLIndex].bg:SetTexture(hero)
				f[BLIndex]:SetAlpha(RaidB_DB.okA)
				
				if RaidB_DB.desaturate then
				f[BLIndex].bg:SetDesaturated(false)
				end
		    else
				f[BLIndex].caster = nil
				f[BLIndex]:SetAlpha(RaidB_DB.koA)
				f[BLIndex].bg:SetTexture(f[BLIndex].bt)
				if RaidB_DB.desaturate then
				f[BLIndex].bg:SetDesaturated(true)
				end
			end
	 end	 

end

function f:PLAYER_ENTERING_WORLD()	
	hooksecurefunc(ConsolidatedBuffs, "Show", function() 
			ConsolidatedBuffs:Hide()
		end)
	ConsolidatedBuffs:UnregisterAllEvents()
	f:PLAYER_AURAS_CHANGED()
	--print(NUM_LE_RAID_BUFF_TYPES)
end

function f:PLAYER_REGEN_ENABLED()
   f:SetAlpha(1)
end

function f:PLAYER_REGEN_DISABLED()
   f:SetAlpha(RaidB_DB.fadeCombatAlpha)
end

function f:unlockFrame()
	print("Frames unlocked")
	print("/srb lock to lock")
	
	if f and f:IsUserPlaced() then
		if RaidB_DB.showifalone == false then
			if not f:IsVisible() then
				f:Show()
			end
		end

		f.dragtexture:SetAlpha(0.2)
		f:EnableMouse(true)
		f:RegisterForDrag("LeftButton")
		
		f:SetScript("OnEnter", function(s) 
		GameTooltip:SetOwner(s, "ANCHOR_TOP")
		GameTooltip:AddLine(s:GetName(), 0, 1, 0.5, 1, 1, 1)
		GameTooltip:AddLine("Hold down SHIFT to drag!", 1, 1, 1, 1, 1, 1)
		GameTooltip:Show()
		end)
		f:SetScript("OnLeave", function(s) GameTooltip:Hide() end)
	end
end  
  
function f:lockFrame()
	print("Frames locked")
	print("/srb unlock to unlock")
	if f and f:IsUserPlaced() then
		if RaidB_DB.showifalone == false then
			if f:IsVisible() then
				f:Hide()
			end
		end
		f.dragtexture:SetAlpha(0)
		f:EnableMouse(nil)
		f:RegisterForDrag(nil)
		f:SetScript("OnEnter", nil)
		f:SetScript("OnLeave", nil)
	end
end

function SacriRaidBuffed_slashHandler(arg1)

	print("SacriRaidBuffed is running")
	print("Options")
	print("/srb unlock")
	print("/srb lock")
	if arg1 == "unlock" then
		f:unlockFrame()
	elseif arg1 == "lock" then
		f:lockFrame()
	end
	
end


SlashCmdList["SacriRaidBuffed"] = SacriRaidBuffed_slashHandler
SLASH_SacriRaidBuffed1 = "/srb"
f:RegisterUnitEvent("ADDON_LOADED", "Player");
function f:RegisterForEvents()

f:RegisterUnitEvent("PLAYER_ENTERING_WORLD", "Player");

	if RaidB_DB.showifalone == false then
	f:RegisterEvent("GROUP_ROSTER_UPDATE")
	end

	if RaidB_DB.fadeCombat then
    f:RegisterEvent("PLAYER_REGEN_ENABLED")
	f:RegisterEvent("PLAYER_REGEN_DISABLED")
	end

end

f:SetScript('OnEvent', function(self, event, ...) self[event](self, event, ...) end)